<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipoTerceirosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTipoTerceirosERP
 * @subpackage Arrays
 */
class ArrayOfTipoTerceirosERP extends AbstractStructArrayBase
{
    /**
     * The TipoTerceirosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipoTerceirosERP[]
     */
    public $TipoTerceirosERP;
    /**
     * Constructor method for ArrayOfTipoTerceirosERP
     * @uses ArrayOfTipoTerceirosERP::setTipoTerceirosERP()
     * @param \StructType\TipoTerceirosERP[] $tipoTerceirosERP
     */
    public function __construct(array $tipoTerceirosERP = array())
    {
        $this
            ->setTipoTerceirosERP($tipoTerceirosERP);
    }
    /**
     * Get TipoTerceirosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipoTerceirosERP[]|null
     */
    public function getTipoTerceirosERP()
    {
        return isset($this->TipoTerceirosERP) ? $this->TipoTerceirosERP : null;
    }
    /**
     * Set TipoTerceirosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipoTerceirosERP[] $tipoTerceirosERP
     * @return \ArrayType\ArrayOfTipoTerceirosERP
     */
    public function setTipoTerceirosERP(array $tipoTerceirosERP = array())
    {
        foreach ($tipoTerceirosERP as $arrayOfTipoTerceirosERPTipoTerceirosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipoTerceirosERPTipoTerceirosERPItem instanceof \StructType\TipoTerceirosERP) {
                throw new \InvalidArgumentException(sprintf('The TipoTerceirosERP property can only contain items of \StructType\TipoTerceirosERP, "%s" given', is_object($arrayOfTipoTerceirosERPTipoTerceirosERPItem) ? get_class($arrayOfTipoTerceirosERPTipoTerceirosERPItem) : gettype($arrayOfTipoTerceirosERPTipoTerceirosERPItem)), __LINE__);
            }
        }
        if (is_null($tipoTerceirosERP) || (is_array($tipoTerceirosERP) && empty($tipoTerceirosERP))) {
            unset($this->TipoTerceirosERP);
        } else {
            $this->TipoTerceirosERP = $tipoTerceirosERP;
        }
        return $this;
    }
    /**
     * Add item to TipoTerceirosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\TipoTerceirosERP $item
     * @return \ArrayType\ArrayOfTipoTerceirosERP
     */
    public function addToTipoTerceirosERP(\StructType\TipoTerceirosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipoTerceirosERP) {
            throw new \InvalidArgumentException(sprintf('The TipoTerceirosERP property can only contain items of \StructType\TipoTerceirosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TipoTerceirosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipoTerceirosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipoTerceirosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipoTerceirosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipoTerceirosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipoTerceirosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipoTerceirosERP
     */
    public function getAttributeName()
    {
        return 'TipoTerceirosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTipoTerceirosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
